/**
 * @file main.c
 * @author WHXY
 * @brief
 * @version 0.1
 * @date 2022-7-12
 *
 * @copyright Copyright (c) 2021
 *
 */
/*******************************************************************************
*
* 代码许可和免责信息
* 武汉芯源半导体有限公司授予您使用所有编程代码示例的非专属的版权许可，您可以由此
* 生成根据您的特定需要而定制的相似功能。根据不能被排除的任何法定保证，武汉芯源半
* 导体有限公司及其程序开发商和供应商对程序或技术支持（如果有）不提供任何明示或暗
* 含的保证或条件，包括但不限于暗含的有关适销性、适用于某种特定用途和非侵权的保证
* 或条件。
* 无论何种情形，武汉芯源半导体有限公司及其程序开发商或供应商均不对下列各项负责，
* 即使被告知其发生的可能性时，也是如此：数据的丢失或损坏；直接的、特别的、附带的
* 或间接的损害，或任何后果性经济损害；或利润、业务、收入、商誉或预期可节省金额的
* 损失。
* 某些司法辖区不允许对直接的、附带的或后果性的损害有任何的排除或限制，因此某些或
* 全部上述排除或限制可能并不适用于您。
*
*******************************************************************************/
#define _MAIN

/******************************************************************************
 * Include files
 ******************************************************************************/
#include "..\inc\main.h"

/******************************************************************************
 * Global variable definitions (declared in header file with 'extern')
 ******************************************************************************/
uint8_t u8DataSent[LEN_DATA_RAM] = {0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07};
uint8_t u8DataReceived[LEN_DATA_RAM] = {0x00};
//...

/******************************************************************************
 * Local type definitions ('typedef')
 ******************************************************************************/

/******************************************************************************
 * Local function prototypes ('static')
 ******************************************************************************/
void VC1_Configuration(void);
void I2C1_Configuration(void);
/******************************************************************************
 * Local variable definitions ('static')                                      *
 ******************************************************************************/

/******************************************************************************
 * Local pre-processor symbols/macros ('#define')
 ******************************************************************************/


/*****************************************************************************
 * Function implementation - global ('extern') and local ('static')
 ******************************************************************************/

/**
 * @brief main函数
 *
 * 初始化系统时钟、I2C的IO口和I2C模块，并通过I2C模块发送和接收数据。
 *
 * @return int32_t 返回0表示程序正常结束。
 */
int32_t main(void)
{   
    uint8_t RegAddr = 0;
    //时钟初始化
    SYSCTRL_Configuration();

    // I2C的IO口初始化
    GPIO_Configuration();
    
    VC1_Configuration();
    I2C1_Configuration();
    
    I2C_MasterSendDataToSlave(CW_I2C1, 0x50, u8DataSent, LEN_DATA_RAM);
    I2C_MasterReceiveDataFromSlave(CW_I2C1, 0x50, &RegAddr, I2C_REG_ADDR_8BIT, u8DataReceived, LEN_DATA_RAM);
    
    while (1)
    {
    }
    
    
  

}

/**
  * @brief  Configures the different system clocks.
  * @param  None
  * @retval None
  */
void SYSCTRL_Configuration(void)
{
    SYSCTRL_HSI_Enable(HSIOSC_TO_HSI32MHZ);
    __SYSCTRL_I2C1_CLK_ENABLE();
    __SYSCTRL_VC_CLK_ENABLE();
}

/**
  * @brief  Configure the GPIO Pins.
  * @param  None
  * @retval None
  */
void GPIO_Configuration(void)
{
    // 设置PA04和PA05为I2C1的SCL和SDA，同时PA04作为VC1的INP2，PA05作为VC2的INP2
    
    GPIO_InitTypeDef GPIO_InitStructure = {0};
    
    __SYSCTRL_GPIOA_CLK_ENABLE();
    
    PA04_AFx_I2C1SCL();
    PA05_AFx_I2C1SDA();
    
    GPIO_InitStructure.Pins = GPIO_PIN_4 | GPIO_PIN_5;
    GPIO_InitStructure.Mode = GPIO_MODE_OUTPUT_OD;
    GPIO_Init(CW_GPIOA, &GPIO_InitStructure);

    /* Configure the GPIO_LED pin */
    GPIO_InitStructure.Pins = GPIO_PIN_8 | GPIO_PIN_9 ;
    GPIO_InitStructure.Mode = GPIO_MODE_OUTPUT_PP;
    GPIO_Init(CW_GPIOB, &GPIO_InitStructure);

    //LEDs are off.
    PB09_SETLOW();
    PB08_SETLOW();
}

void VC1_Configuration(void)
{
    VC_InitTypeDef VC_InitStructure = {0};
    
    VC_InitStructure.div = VC_DIV_7;
    VC_InitStructure.filterConfig.FilterClock = VC_FILTER_CLOCK_PCLK;
    VC_InitStructure.filterConfig.FilterTime = VC_FILTER_DISABLE;
    VC_InitStructure.hysteresisEnable = TRUE;
    VC_InitStructure.inputNegative = VC_INN_REF;
    VC_InitStructure.inputPositive = VC_INP_IN2;
    VC_InitStructure.interruptMode = VC_INT_DISABLE;
    VC_InitStructure.polarityInvert = FALSE;
    VC_InitStructure.RefVoltage = VC_REF_VCORE;
    VC_InitStructure.responseSpeed = VC_RESPONSE_FAST;
    
    VC_Init(CW_VC1, &VC_InitStructure);
    VC_Init(CW_VC2, &VC_InitStructure);
    
    VC_Cmd(CW_VC1, ENABLE);
    VC_Cmd(CW_VC2, ENABLE);
}


void I2C1_Configuration(void)
{
    I2C_MasterConfigTypeDef I2C_InitStruct = {0};
    
    // I2C初始化为默认值
    I2C_MasterInitDefault(&I2C_InitStruct);
    
    I2C_InitStruct.I2C_SCL_Source = I2C_SCL_INSRC_VC1_OUT;
    I2C_InitStruct.I2C_SDA_Source = I2C_SDA_INSRC_VC2_OUT;
    I2C_InitStruct.I2C_BaudRate_Hz = 100000;
    
    I2C_MasterInit(CW_I2C1, &I2C_InitStruct, 32000000UL);
    I2C_MasterCmd(CW_I2C1, ENABLE);    
}



/******************************************************************************
 * EOF (not truncated)
 ******************************************************************************/
#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{
    /* USER CODE BEGIN 6 */
    /* User can add his own implementation to report the file name and line number */
    printf("Wrong parameters value: file %s on line %d\r\n", file, line);
    /* USER CODE END 6 */
}

#endif

